<?php
/* 
The right way to detect visitor language preference.
Developed for the OmegaJunior.Net.
Copyleft A.E.Veltstra, 2009.
Use and change to your heart's content.
*/
function zjrAcceptLanguage(){
  $strRequestLang = '';
	/* test if the visitor's browser provided a language preference at all */
	if(!empty($_SERVER['HTTP_ACCEPT_LANGUAGE'])){
	 /* retrieve and secure the provided language preferences */
	 $strAcceptLangs = strtolower(htmlspecialchars(''.$_SERVER['HTTP_ACCEPT_LANGUAGE']));
	 /* if more language preferences are present, they should be separated using comma's */
	 $arrAcceptLangs = explode(',',$strAcceptLangs);
	 /* we count how many preferences were provided */
	 $cntAcceptLangs = count($arrAcceptLangs);
	 /* skip if count = 0 */
	 if($cntAcceptLangs){
	  /* we compare the preference with the languages we claim to support */
		$strProvidedLangs = strtolower(',en,nl,');
		for($i=0;$i<$cntAcceptLangs;$i++){
		 $strLangID=$arrAcceptLangs[$i];
		 /* if more language preferences were present, any beyond the first one may have 
		    a quality indicator, separated from the language using a semicolon */
		 if(strpos($strLangID,';')!==false){
			$arrLangID=explode(';',$strLangID);
			/* we trim off the qualifier and return the language indicator */
			$strLangID=$arrLangID[0];
		 }
		 /* the language indicator may contain a dialect indicator, separated using a dash */
		 if(strpos($strLangID,'-')!==false){
			$arrLangID=explode('-',$strLangID);
			/* we trim off the dash and return the main part only */
			$strLangID=$arrLangID[0];
		 }
		 /* now we compare what's left with the languages we claim to support */
		 if(strpos($strProvidedLangs,','.$strLangID.',')!==false){
		  /* we found one */
			$strRequestLang=$strLangID;
			/* since we want to provide the most preferred language, 
			   we now break our search and return our find */
			break;
		 }
		} /* end for */
	 } /* end if($cntAcceptLangs) */
	} /* end if(HTTP_ACCEPT_LANGUAGE) */
	return $strRequestLang;
} /* end function */
?>